VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4935
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   17055
   LinkTopic       =   "Form1"
   ScaleHeight     =   4935
   ScaleWidth      =   17055
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command5 
      Caption         =   "Test5"
      Height          =   375
      Left            =   2520
      TabIndex        =   8
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Test4"
      Height          =   375
      Left            =   1320
      TabIndex        =   7
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Test3"
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Random Matrices"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   600
      Width           =   1575
   End
   Begin VB.CommandButton BtnCalc 
      Caption         =   "="
      Height          =   375
      Left            =   10800
      TabIndex        =   4
      Top             =   720
      Width           =   1095
   End
   Begin VB.TextBox Text3 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2415
      Left            =   11400
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Beides
      TabIndex        =   3
      Top             =   1080
      Width           =   5535
   End
   Begin VB.ComboBox CmbOps 
      Height          =   315
      Left            =   5160
      TabIndex        =   2
      Text            =   "Combo1"
      Top             =   720
      Width           =   1095
   End
   Begin VB.TextBox Text2 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2415
      Left            =   5760
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Beides
      TabIndex        =   1
      Top             =   1080
      Width           =   5535
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2415
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Beides
      TabIndex        =   0
      Top             =   1080
      Width           =   5535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


'zum berprfen der Berechnung siehe z.B.:
'http://matrizen-rechner.de/
'https://matrixcalc.org/de/
'https://rechneronline.de/lineare-algebra/matrizen.php
'https://rechneronline.de/lineare-algebra/gleichungssysteme.php

Private Sub Command3_Click()
    Dim a4 As Matrix4
    Dim t As String
    a4 = Mat4(11, 12, 13, -14, _
              21, 22, 23, 24, _
              31, 32, 33, 34, _
              41, 42, 43, 44)
    t = Matrix4_ToStr(a4)
    MsgBox t
    a4 = Matrix4_Parse(t)
    t = Matrix4_ToStr(a4)
    MsgBox t
    Dim d As Double: d = Matrix4_det(a4)
    MsgBox d
End Sub

Private Sub Command4_Click()
    'Test2
    'Test3
    'Test4
    'Test5
    'Test6
    Test_umat5
End Sub

Sub Test_umat3()
    Dim m As Matrix3: m = Mat3(11, 12, 13, _
                               21, 22, 23, _
                               31, 32, 33)
    Dim i As Long, j As Long
    For i = 0 To 2: For j = 0 To 2
        Dim um As Matrix2: um = Matrix3_umat(m, i, j)
        Debug.Print Matrix2_ToStr(um)
    Next: Next
End Sub
Sub Test_umat4()
    Dim m As Matrix4: m = Mat4(11, 12, 13, 14, _
                               21, 22, 23, 24, _
                               31, 32, 33, 34, _
                               41, 42, 43, 44)
    Dim i As Long, j As Long
    For i = 0 To 3: For j = 0 To 3
        Dim um As Matrix3: um = Matrix4_umat(m, i, j)
        Debug.Print Matrix3_ToStr(um)
    Next: Next
End Sub
Sub Test_umat5()
    Dim m As Matrix5: m = Mat5(11, 12, 13, 14, 15, _
                               21, 22, 23, 24, 25, _
                               31, 32, 33, 34, 35, _
                               41, 42, 43, 44, 45, _
                               51, 52, 53, 54, 55)
    Dim i As Long, j As Long
    For i = 0 To 4: For j = 0 To 4
        Dim um As Matrix4: um = Matrix5_umat(m, i, j)
        Debug.Print Matrix4_ToStr(um)
    Next: Next
End Sub
Sub Test_umat6()
    Dim m As Matrix6: m = Mat6(11, 12, 13, 14, 15, 16, _
                               21, 22, 23, 24, 25, 26, _
                               31, 32, 33, 34, 35, 36, _
                               41, 42, 43, 44, 45, 46, _
                               51, 52, 53, 54, 55, 56, _
                               61, 62, 63, 64, 65, 66)
    Dim i As Long, j As Long
    For i = 0 To 5: For j = 0 To 5
        Dim um As Matrix5: um = Matrix6_umat(m, i, j)
        Debug.Print Matrix5_ToStr(um)
    Next: Next
End Sub

'Test Property Get/Let Row / Col
Sub Test2()
    Dim m1 As Matrix2, m2 As Matrix2
    Mat2_Row(m1, 0) = Vec2(11, 12)
    Mat2_Row(m1, 1) = Vec2(21, 22)
    MsgBox Matrix2_ToStr(m1)
    MsgBox Vector2_ToStr(Mat2_Row(m1, 0), True)
    MsgBox Vector2_ToStr(Mat2_Row(m1, 1), True)
    
    Mat2_Col(m2, 0) = Vec2(11, 21)
    Mat2_Col(m2, 1) = Vec2(12, 22)
    MsgBox Matrix2_ToStr(m2)
    MsgBox Vector2_ToStr(Mat2_Col(m2, 0), False)
    MsgBox Vector2_ToStr(Mat2_Col(m2, 1), False)
End Sub
Sub Test3()
    Dim m1 As Matrix3, m2 As Matrix3
    Mat3_Row(m1, 0) = Vec3(11, 12, 13)
    Mat3_Row(m1, 1) = Vec3(21, 22, 23)
    Mat3_Row(m1, 2) = Vec3(31, 32, 33)
    MsgBox Matrix3_ToStr(m1)
    MsgBox Vector3_ToStr(Mat3_Row(m1, 0), True)
    MsgBox Vector3_ToStr(Mat3_Row(m1, 1), True)
    MsgBox Vector3_ToStr(Mat3_Row(m1, 2), True)
    
    Mat3_Col(m2, 0) = Vec3(11, 21, 31)
    Mat3_Col(m2, 1) = Vec3(12, 22, 32)
    Mat3_Col(m2, 2) = Vec3(13, 23, 33)
    MsgBox Matrix3_ToStr(m2)
    MsgBox Vector3_ToStr(Mat3_Col(m2, 0), False)
    MsgBox Vector3_ToStr(Mat3_Col(m2, 1), False)
    MsgBox Vector3_ToStr(Mat3_Col(m2, 2), False)
End Sub
Sub Test4()
    Dim m1 As Matrix4, m2 As Matrix4
    Mat4_Row(m1, 0) = Vec4(11, 12, 13, 14)
    Mat4_Row(m1, 1) = Vec4(21, 22, 23, 24)
    Mat4_Row(m1, 2) = Vec4(31, 32, 33, 34)
    Mat4_Row(m1, 3) = Vec4(41, 42, 43, 44)
    MsgBox Matrix4_ToStr(m1)
    MsgBox Vector4_ToStr(Mat4_Row(m1, 0), True)
    MsgBox Vector4_ToStr(Mat4_Row(m1, 1), True)
    MsgBox Vector4_ToStr(Mat4_Row(m1, 2), True)
    MsgBox Vector4_ToStr(Mat4_Row(m1, 3), True)
    
    Mat4_Col(m2, 0) = Vec4(11, 21, 31, 41)
    Mat4_Col(m2, 1) = Vec4(12, 22, 32, 42)
    Mat4_Col(m2, 2) = Vec4(13, 23, 33, 43)
    Mat4_Col(m2, 3) = Vec4(14, 24, 34, 44)
    MsgBox Matrix4_ToStr(m2)
    MsgBox Vector4_ToStr(Mat4_Col(m2, 0), False)
    MsgBox Vector4_ToStr(Mat4_Col(m2, 1), False)
    MsgBox Vector4_ToStr(Mat4_Col(m2, 2), False)
    MsgBox Vector4_ToStr(Mat4_Col(m2, 3), False)
End Sub
Sub Test5()
    Dim m1 As Matrix5, m2 As Matrix5
    Mat5_Row(m1, 0) = Vec5(11, 12, 13, 14, 15)
    Mat5_Row(m1, 1) = Vec5(21, 22, 23, 24, 25)
    Mat5_Row(m1, 2) = Vec5(31, 32, 33, 34, 35)
    Mat5_Row(m1, 3) = Vec5(41, 42, 43, 44, 45)
    Mat5_Row(m1, 4) = Vec5(51, 52, 53, 54, 55)
    MsgBox Matrix5_ToStr(m1)
    MsgBox Vector5_ToStr(Mat5_Row(m1, 0), True)
    MsgBox Vector5_ToStr(Mat5_Row(m1, 1), True)
    MsgBox Vector5_ToStr(Mat5_Row(m1, 2), True)
    MsgBox Vector5_ToStr(Mat5_Row(m1, 3), True)
    MsgBox Vector5_ToStr(Mat5_Row(m1, 4), True)
    
    Mat5_Col(m2, 0) = Vec5(11, 21, 31, 41, 51)
    Mat5_Col(m2, 1) = Vec5(12, 22, 32, 42, 52)
    Mat5_Col(m2, 2) = Vec5(13, 23, 33, 43, 53)
    Mat5_Col(m2, 3) = Vec5(14, 24, 34, 44, 54)
    Mat5_Col(m2, 4) = Vec5(15, 25, 35, 45, 55)
    MsgBox Matrix5_ToStr(m2)
    MsgBox Vector5_ToStr(Mat5_Col(m2, 0), False)
    MsgBox Vector5_ToStr(Mat5_Col(m2, 1), False)
    MsgBox Vector5_ToStr(Mat5_Col(m2, 2), False)
    MsgBox Vector5_ToStr(Mat5_Col(m2, 3), False)
    MsgBox Vector5_ToStr(Mat5_Col(m2, 4), False)
End Sub
Sub Test6()
    Dim m1 As Matrix6, m2 As Matrix6
    Mat6_Row(m1, 0) = Vec6(11, 12, 13, 14, 15, 16)
    Mat6_Row(m1, 1) = Vec6(21, 22, 23, 24, 25, 26)
    Mat6_Row(m1, 2) = Vec6(31, 32, 33, 34, 35, 36)
    Mat6_Row(m1, 3) = Vec6(41, 42, 43, 44, 45, 46)
    Mat6_Row(m1, 4) = Vec6(51, 52, 53, 54, 55, 56)
    Mat6_Row(m1, 5) = Vec6(61, 62, 63, 64, 65, 66)
    MsgBox Matrix6_ToStr(m1)
    MsgBox Vector6_ToStr(Mat6_Row(m1, 0), True)
    MsgBox Vector6_ToStr(Mat6_Row(m1, 1), True)
    MsgBox Vector6_ToStr(Mat6_Row(m1, 2), True)
    MsgBox Vector6_ToStr(Mat6_Row(m1, 3), True)
    MsgBox Vector6_ToStr(Mat6_Row(m1, 4), True)
    MsgBox Vector6_ToStr(Mat6_Row(m1, 5), True)
    
    Mat6_Col(m2, 0) = Vec6(11, 21, 31, 41, 51, 61)
    Mat6_Col(m2, 1) = Vec6(12, 22, 32, 42, 52, 62)
    Mat6_Col(m2, 2) = Vec6(13, 23, 33, 43, 53, 63)
    Mat6_Col(m2, 3) = Vec6(14, 24, 34, 44, 54, 64)
    Mat6_Col(m2, 4) = Vec6(15, 25, 35, 45, 55, 65)
    Mat6_Col(m2, 5) = Vec6(16, 26, 36, 46, 56, 66)
    MsgBox Matrix6_ToStr(m2)
    MsgBox Vector6_ToStr(Mat6_Col(m2, 0), False)
    MsgBox Vector6_ToStr(Mat6_Col(m2, 1), False)
    MsgBox Vector6_ToStr(Mat6_Col(m2, 2), False)
    MsgBox Vector6_ToStr(Mat6_Col(m2, 3), False)
    MsgBox Vector6_ToStr(Mat6_Col(m2, 4), False)
    MsgBox Vector6_ToStr(Mat6_Col(m2, 5), False)
End Sub

Private Sub Command5_Click()
    MsgBox Matrix6_ToStr(Mat6_E)
End Sub

'Matrix-Tipp
'einfache Matrizenoperationen fr kleine Matrizen bis 6x6
'Addieren (add), Subtrahieren (sub), Multiplizieren (mul), Skalar-Multiplikation (smul), Transponierte (tra), Determinante (det), Adjunkte (adj), Inverse (inv)
'add, sub, mul, tra, det, adj, inv
Private Sub Form_Load()
    Me.Caption = "Matrizen - bis 6x6"
    With CmbOps
        .Font = "Courier New": .FontSize = 10
        .AddItem "  +  ": .AddItem "  -  ": .AddItem "  *  ": .AddItem " tra ": .AddItem " det ": .AddItem " adj ": .AddItem " inv ": .AddItem "  =  "
        .AddItem "A*x=b" 'noch nicht implementiert
        .ListIndex = 0
    End With
    Randomize
    Text1.Text = GetRandomMat
    Text2.Text = Text1.Text
End Sub

Private Sub BtnCalc_Click()

    Dim A2 As Matrix2, b2 As Matrix2, C2 As Matrix2
    Dim A3 As Matrix3, b3 As Matrix3, C3 As Matrix3
    Dim a4 As Matrix4, b4 As Matrix4, C4 As Matrix4
    Dim A5 As Matrix5, b5 As Matrix5, C5 As Matrix5
    Dim A6 As Matrix6, b6 As Matrix6, C6 As Matrix6
    'die maximalen Gren der Matrizen herausfinden
    Dim A_mRows As Long, A_nCols As Long
    Dim B_mRows As Long, B_nCols As Long
    GetRowsCols Text1.Text, A_mRows, A_nCols
    GetRowsCols Text2.Text, B_mRows, B_nCols
    Dim maxrc As Long: maxrc = Max(A_mRows, Max(B_mRows, Max(A_nCols, B_nCols)))
    
    Select Case maxrc
    Case 2: A2 = Matrix2_Parse(Text1.Text): b2 = Matrix2_Parse(Text2.Text)
    Case 3: A3 = Matrix3_Parse(Text1.Text): b3 = Matrix3_Parse(Text2.Text)
    Case 4: a4 = Matrix4_Parse(Text1.Text): b4 = Matrix4_Parse(Text2.Text)
    Case 5: A5 = Matrix5_Parse(Text1.Text): b5 = Matrix5_Parse(Text2.Text)
    Case 6: A6 = Matrix6_Parse(Text1.Text): b6 = Matrix6_Parse(Text2.Text)
    End Select
    'Dim C6 As Matrix6
    Dim scalar As Double
    Dim op As String: op = CmbOps.List(CmbOps.ListIndex)
    If op = "  *  " And (A_mRows = 1 And A_nCols = 1) Or (B_mRows = 1 And B_nCols = 1) Then
        op = "smul"
        scalar = Val(Text2.Text)
    End If
    Select Case op
    Case "  +  "
        Select Case maxrc
        Case 2: C2 = Matrix2_add(A2, b2):  LSet C6 = C2
        Case 3: C3 = Matrix3_add(A3, b3):  LSet C6 = C3
        Case 4: C4 = Matrix4_add(a4, b4):  LSet C6 = C4
        Case 5: C5 = Matrix5_add(A5, b5):  LSet C6 = C5
        Case 6: C6 = Matrix6_add(A6, b6)
        End Select
    Case "  -  "
        Select Case maxrc
        Case 2: C2 = Matrix2_sub(A2, b2): LSet C6 = C2
        Case 3: C3 = Matrix3_sub(A3, b3): LSet C6 = C3
        Case 4: C4 = Matrix4_sub(a4, b4): LSet C6 = C4
        Case 5: C5 = Matrix5_sub(A5, b5): LSet C6 = C5
        Case 6: C6 = Matrix6_sub(A6, b6)
        End Select
    Case "smul"
        Select Case maxrc
        Case 2: C2 = Matrix2_smul(A2, scalar): LSet C6 = C2
        Case 3: C3 = Matrix3_smul(A3, scalar): LSet C6 = C3
        Case 4: C4 = Matrix4_smul(a4, scalar): LSet C6 = C4
        Case 5: C5 = Matrix5_smul(A5, scalar): LSet C6 = C5
        Case 6: C6 = Matrix6_smul(A6, scalar)
        End Select
    Case "  *  "
        Select Case maxrc
        Case 2: C2 = Matrix2_mul(A2, b2): LSet C6 = C2
        Case 3: C3 = Matrix3_mul(A3, b3): LSet C6 = C3
        Case 4: C4 = Matrix4_mul(a4, b4): LSet C6 = C4
        Case 5: C5 = Matrix5_mul(A5, b5): LSet C6 = C5
        Case 6: C6 = Matrix6_mul(A6, b6)
        End Select
    Case " tra "
        Select Case maxrc
        Case 2: C2 = Matrix2_tra(A2): LSet C6 = C2
        Case 3: C3 = Matrix3_tra(A3): LSet C6 = C3
        Case 4: C4 = Matrix4_tra(a4): LSet C6 = C4
        Case 5: C5 = Matrix5_tra(A5): LSet C6 = C5
        Case 6: C6 = Matrix6_tra(A6)
        End Select
    Case "  =  "
        Dim b As Boolean
        Select Case maxrc
        Case 2: b = Matrix2_IsEqual(A2, b2)
        Case 3: b = Matrix3_IsEqual(A3, b3)
        Case 4: b = Matrix4_IsEqual(a4, b4)
        Case 5: b = Matrix5_IsEqual(A5, b5)
        Case 6: b = Matrix6_IsEqual(A6, b6)
        End Select
    Case " det "
        Dim d As Double, d2 As Double
        Select Case maxrc
        Case 2: d = Matrix2_det(A2)
        Case 3: d = Matrix3_det(A3) ': d2 = Matrix3_det2(A3)
        Case 4: d = Matrix4_det(a4)
        Case 5: d = Matrix5_det(A5)
        Case 6: d = Matrix6_det(A6)
        End Select
    Case " adj "
        Select Case maxrc
        Case 2: C2 = Matrix2_Adj(A2):  LSet C6 = C2
        Case 3: C3 = Matrix3_Adj(A3):  LSet C6 = C3
        Case 4: C4 = Matrix4_Adj(a4):  LSet C6 = C4
        Case 5: C5 = Matrix5_Adj(A5):  LSet C6 = C5
        Case 6: C6 = Matrix6_Adj(A6)
        End Select
    Case " inv "
        Select Case maxrc
        Case 2: C2 = Matrix2_inv(A2):  LSet C6 = C2
        Case 3: C3 = Matrix3_inv(A3):  LSet C6 = C3
        Case 4: C4 = Matrix4_inv(a4):  LSet C6 = C4
        Case 5: C5 = Matrix5_inv(A5):  LSet C6 = C5
        Case 6: C6 = Matrix6_inv(A6)
        End Select
    Case "A*x=b"
        Dim vb2 As Vector2, vb3 As Vector3, vb4 As Vector4, vb5 As Vector5, vb6 As Vector6
        Dim vx2 As Vector2, vx3 As Vector3, vx4 As Vector4, vx5 As Vector5, vx6 As Vector6
        'z.B.: A[-2 -2 | -1  1] * x[-2 | 0] = b [ 4 | 2 ];
        'z.B.: A[ 5  6 |  3  4] * x[-13|12] = b [ 7 | 8 ];
        Select Case maxrc
        Case 2: vb2 = Mat2_Col(Matrix2_Parse(Text3.Text), 0) ': Debug.Print Vector2_ToStr(vb2)
                vx2 = Matrix2_solve(A2, vb2):                 'Debug.Print Vector2_ToStr(vx2) '  LSet C6 = C2
        Case 3: vb3 = Mat3_Col(Matrix3_Parse(Text3.Text), 0) ': Debug.Print Vector3_ToStr(vb3)
                vx3 = Matrix3_solve(A3, vb3):                 'Debug.Print Vector3_ToStr(vx3) '  LSet C6 = C2
        Case 4: vb4 = Mat4_Col(Matrix4_Parse(Text3.Text), 0) ': Debug.Print Vector3_ToStr(vb3)
                vx4 = Matrix4_solve(a4, vb4):                 'Debug.Print Vector3_ToStr(vx3) '  LSet C6 = C2
        Case 5: vb5 = Mat5_Col(Matrix5_Parse(Text3.Text), 0) ': Debug.Print Vector3_ToStr(vb3)
                vx5 = Matrix5_solve(A5, vb5):                 'Debug.Print Vector3_ToStr(vx3) '  LSet C6 = C2
        Case 6: vb6 = Mat6_Col(Matrix6_Parse(Text3.Text), 0) ': Debug.Print Vector3_ToStr(vb3)
                vx6 = Matrix6_solve(A6, vb6):                 'Debug.Print Vector3_ToStr(vx3) '  LSet C6 = C2
        End Select
    End Select
    
    Select Case maxrc
    Case 2: Text1.Text = Matrix2_ToStr(A2): Text2.Text = Matrix2_ToStr(b2)
    Case 3: Text1.Text = Matrix3_ToStr(A3): Text2.Text = Matrix3_ToStr(b3)
    Case 4: Text1.Text = Matrix4_ToStr(a4): Text2.Text = Matrix4_ToStr(b4)
    Case 5: Text1.Text = Matrix5_ToStr(A5): Text2.Text = Matrix5_ToStr(b5)
    Case 6: Text1.Text = Matrix6_ToStr(A6): Text2.Text = Matrix6_ToStr(b6)
    End Select
    'If Not op = "smul" Then
    'End If
    Dim t As String
    If op = "  =  " Then
        t = b
        Text3.Text = t
    ElseIf op = " det " Then
        t = Str(d) '& vbCrLf & Str(d2)
        Text3.Text = t
    ElseIf op = "A*x=b" Then
        Select Case maxrc
        Case 2: t = Vector2_ToStr(vx2, False)
        Case 3: t = Vector3_ToStr(vx3, False)
        Case 4: t = Vector4_ToStr(vx4, False)
        Case 5: t = Vector5_ToStr(vx5, False)
        Case 6: t = Vector6_ToStr(vx6, False)
        End Select
        Text2.Text = t
    Else
        t = Matrix_ToStr(VarPtr(C6), maxrc, maxrc)
        Text3.Text = t
    End If



End Sub

Sub GetRowsCols(t As String, ByRef rows_out As Long, ByRef cols_out As Long)
    rows_out = GetRows(t):    cols_out = GetCols(t)
End Sub
Function GetRows(t As String) As Long
    Dim s As String: s = DeleteMultiWS(t)
    Dim sa() As String: sa = Split(s, vbCrLf)
    Dim i As Long
    GetRows = UBound(sa) + 1
    For i = UBound(sa) To 0 Step -1
        If Len(sa(i)) = 0 Then GetRows = GetRows - 1 Else Exit For
    Next
End Function
Function GetCols(t As String) As Long
    Dim s As String: s = DeleteMultiWS(t)
    Dim sa() As String: sa = Split(s, vbCrLf)
    Dim i As Long
    For i = 0 To UBound(sa)
        GetCols = Max(GetCols, UBound(Split(Trim(sa(i)), " ")) + 1)
    Next
End Function

Private Sub Command2_Click()
    Text1.Text = GetRandomMat
    Text2.Text = GetRandomMat 'Text1.Text
    Text3.Text = ""
    BtnCalc_Click
End Sub

Function GetRandomMat() As String
    Dim r As Long: r = Rnd * 10 + 2
    Select Case r
    Case 2: GetRandomMat = GetMat2
    Case 3: GetRandomMat = GetMat3
    Case 4: GetRandomMat = GetMat4
    Case 5: GetRandomMat = GetMat5
    Case 6: GetRandomMat = GetMat6
    Case Else
            GetRandomMat = GetRndMat
    End Select
End Function

Function GetRndMat() As String
    Dim size As Long: size = Rnd * 4 + 2
    Dim s As String
    'ReDim a(0 To size - 1, 0 To size - 1)
    Dim i As Long, j As Long
    For i = 1 To size 'UBound(a, 1)
        For j = 1 To size 'UBound(a, 2)
            'a(i, j) =  Rnd * 200 * Sgn(Rnd - 0.5)
            s = s & Replace(Format(Rnd * 200 * Sgn(Rnd - 0.5), "0.00"), ",", ".") & " "
        Next
        s = s & vbCrLf
    Next
    GetRndMat = s
End Function
Function GetMat2() As String
    GetMat2 = "11 12" & vbCrLf & _
              "21 22"
End Function
Function GetMat3() As String
    GetMat3 = "11 12 13" & vbCrLf & _
              "21 22 23" & vbCrLf & _
              "31 32 33"
End Function
Function GetMat4() As String
    GetMat4 = "11 12 13 14" & vbCrLf & _
              "21 22 23 24" & vbCrLf & _
              "31 32 33 34" & vbCrLf & _
              "41 42 43 44"
End Function
Function GetMat5() As String
    GetMat5 = "11 12 13 14 15" & vbCrLf & _
              "21 22 23 24 25" & vbCrLf & _
              "31 32 33 34 35" & vbCrLf & _
              "41 42 43 44 45" & vbCrLf & _
              "51 52 53 54 55"
End Function
Function GetMat6() As String
    GetMat6 = "11 12 13 14 15 16" & vbCrLf & _
              "21 22 23 24 25 26" & vbCrLf & _
              "31 32 33 34 35 36" & vbCrLf & _
              "41 42 43 44 45 46" & vbCrLf & _
              "51 52 53 54 55 56" & vbCrLf & _
              "61 62 63 64 65 66"
End Function

Private Sub Form_Resize()
    Dim brdr: brdr = 8 * Screen.TwipsPerPixelX
    Dim L, t, W, H
    Dim L2
    L = brdr: t = Text1.Top
    W = (Me.ScaleWidth - 4 * brdr) / 3
    H = Me.ScaleHeight - t - brdr
    If W > 0 And H > 0 Then
        Text1.Move L, t, W, H
        L = L + Text1.Width + brdr
        L2 = L - (brdr + CmbOps.Width) / 2
        CmbOps.Move L2, t - CmbOps.Height
        Text2.Move L, t, W, H
        L = L + Text2.Width + brdr
        L2 = L - (brdr + BtnCalc.Width) / 2
        BtnCalc.Move L2, t - BtnCalc.Height
        Text3.Move L, t, W, H
    End If
End Sub
